﻿using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Export_Data_Database_CSV_Razor_Core.Models;
using System.Linq;
using System.Text;

namespace Export_Data_Database_CSV_Razor_Core.Pages
{
    public class IndexModel : PageModel
    {
        private DBCtx Context { get; }

        public IndexModel(DBCtx _context)
        {
            this.Context = _context;
        }

        public List<Customer> Customers { get; set; }

        public void OnGet()
        {
            this.Customers = this.Context.Customers.Take(10).ToList();
        }

        public FileResult OnPostExport()
        {
            List<object> customers = (from customer in this.Context.Customers.Take(10)
                                      select new[] {
                                            customer.CustomerID,
                                            customer.ContactName,
                                            customer.City,
                                            customer.Country
                                    }).ToList<object>();

            //Insert the Column Names.
            customers.Insert(0, new string[4] { "Customer ID", "Customer Name", "City", "Country" });

            StringBuilder sb = new StringBuilder();
            for (int i = 0; i < customers.Count; i++)
            {
                string[] customer = (string[])customers[i];
                for (int j = 0; j < customer.Length; j++)
                {
                    //Append data with separator.
                    sb.Append(customer[j] + ',');
                }

                //Append new line character.
                sb.Append("\r\n");

            }

            return File(Encoding.UTF8.GetBytes(sb.ToString()), "text/csv", "Grid.csv");
        }
    }
}